﻿using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace FanduinaV3CS
{
    // ファン1台分の情報を表示するクラス
    public partial class SidePanelFanParts : UserControl
    {
        //プロパティ
        public Int32 FicNum             //ファンコン番号（Ficでの登録番号）
        {
            get{return ficNum;}
            set
            {
                ficNum = value;
                foreach (ToolStripMenuItem item in controllerNumMenu.DropDownItems)
                {
                    if (Convert.ToInt32(item.Text) == value)
                    {
                        item.Checked = true;
                    }
                    else
                    {
                        item.Checked = false;
                    }
                }
            }
        }
        public Int32 FanNum             //ファン番号
        {
            get{return fanNum;}
            set
            {
                fanNum = value;
                foreach (ToolStripMenuItem item in fanNumMenu.DropDownItems)
                {
                    if (Convert.ToInt32(item.Text) == value+1)
                    {
                        item.Checked = true;
                    }
                    else
                    {
                        item.Checked = false;
                    }
                }
            }
        }
        public FanDataStruct  FanData   //ファン表示用データ
        {
            set
            {
                dispFanNameText = value.FanName;
                dispFanName.Text = value.FanName;
                dispFanTachVal = value.FanTach;
                dispFanTach.Text = Convert.ToString(value.FanTach); 
                dispFanDutyVal = (Int32)(value.FanDuty + 0.5);
                dispFanDuty.FanDuty = dispFanDutyVal;
            }
        }
        public Double   ResizeRate      //ファン表示エリアの倍率
        {
            get { return rate; }
            set
            {
                rate = value;
            }
        }
        public String   FontName        //フォント名称
        {
            get { return dispFanFontName; }
            set
            {
                dispFanFontName = value;
            }
        }
        public Int32    FontSize        //フォントサイズ(pt)
        {
            get { return dispFanFontSize; }
            set
            {
                dispFanFontSize = value;
            }
        }
        public Color    FanColor        //ファン共通色
        {
            get { return fanColor; }
            set
            {
                fanColor = value;
                if (fanColorCommon == true)
                {
                    dispFanName.ForeColor = value;
                    dispFanTach.ForeColor = value;
                    dispFanDuty.FanDutyBarColor = value;
                    //BarGraphPict.BarColor = value;
                }
            }
        }
        public Color    FanTextColor    //ファン個別色
        {
            get { return fanTextColor; }
            set
            {
                fanTextColor = value;
                if (fanColorCommon == false)
                {
                    dispFanName.ForeColor = value;
                    dispFanTach.ForeColor = value;
                }
            }
        }
        public Color    FanBarColor     //グラフ個別色
        {
            get { return fanBarColor; }
            set
            {
                fanBarColor = value;
                if (fanColorCommon == false)
                {
                    dispFanDuty.FanDutyBarColor = value;
                }
            }
        }
        public bool     FanColorCommon  //共通色使用の有無
        {
            get { return fanColorCommon; }
            set 
            {
                fanColorCommon = value;
                if (value == true)
                {
                    dispFanName.ForeColor = fanColor;
                    dispFanTach.ForeColor = fanColor;
                    dispFanDuty.FanDutyBarColor = fanColor;
                }
                else
                {
                    dispFanName.ForeColor = fanTextColor;
                    dispFanTach.ForeColor = fanTextColor;
                    dispFanDuty.FanDutyBarColor = fanBarColor;
                }
            }
        }
        //コンストラクタ
        public SidePanelFanParts()           
        {
            InitializeComponent();
            Load += SidePanelFanParts_Load;
        }
        //メソッド
        public void     RefreshDisp()   //サイズ、フォント、色のプロパティに合わせてファンを再表示するメソッド
        {
            this.Size = new Size((Int32)(dispSize.Width  * rate),
                                 (Int32)(dispSize.Height * rate));
            this.dispFanName.Size = new Size((Int32)(dispFanNameSize.Width  * rate),
                                             (Int32)(dispFanNameSize.Height * rate));
            this.dispFanName.Location = new Point((Int32)(dispFanNameLoc.X * rate),
                                                  (Int32)(dispFanNameLoc.Y * rate));
            this.dispFanName.Font = new Font(dispFanFontName, (float)(dispFanFontSize * rate));
            this.dispFanTach.Size = new Size((Int32)(dispFanTachSize.Width  * rate),
                                             (Int32)(dispFanTachSize.Height * rate));
            this.dispFanTach.Location = new Point((Int32)(dispFanTachLoc.X * rate),
                                                  (Int32)(dispFanTachLoc.Y * rate));
            this.dispFanTach.Font = new Font(dispFanFontName, (float)(dispFanFontSize * rate));
            this.dispFanDuty.ResizeRate = rate;
            this.dispFanDuty.Location =  new Point((Int32)(dispFanDutyLoc.X * rate),
                                                   (Int32)(dispFanDutyLoc.Y * rate));
            //this.dispFanDuty.FontName = dispFanFontName;
            this.dispFanDuty.FontSize = dispFanFontSize;
        }
        //フィールド変数
        private Int32   ficNum;
        private Int32   fanNum;
        private Double  rate;
        private Color   fanColor;
        private Color   fanTextColor;
        private Color   fanBarColor;
        private bool    fanColorCommon;
        private String  dispFanNameText = "AAAAAA";
        private Int32   dispFanTachVal  = 19999;
        private Int32   dispFanDutyVal  = 100;
        private String  dispFanFontName = "tahoma";
        private Int32   dispFanFontSize = 9;
        //ロード時初期化
        private void SidePanelFanParts_Load(object sender, EventArgs e)
        {
            ToolStripMenuItem item = new ToolStripMenuItem();
            for (Int32 i = 0; i < FanduinaSettings.FicMax; i++)
            {
                item = new ToolStripMenuItem(i.ToString());
                controllerNumMenu.DropDownItems.Add(item);
            }
            for (Int32 i = 0; i < FanduinaSettings.FicFanMax; i++)
            {
                item = new ToolStripMenuItem((i+1).ToString());
                fanNumMenu.DropDownItems.Add(item);
            }
        }
        //ローカル変数
        private Size    dispSize        = new Size (156, 16);
        private Size    dispFanNameSize = new Size ( 66, 16);
        private Point   dispFanNameLoc  = new Point(  3,  0);	//V3CSと相違
        private Size    dispFanTachSize = new Size ( 42, 16);
        private Point   dispFanTachLoc  = new Point( 56,  0);	//V3CSと相違
        private Size    dispFanDutySize = new Size ( 50, 16);
        private Point   dispFanDutyLoc  = new Point(100,  0);
        //クリック時のイベント処理
        private void controllerNumMenu_DropDownItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            Int32 i = Convert.ToInt32(e.ClickedItem.Text);
            FicNum = i;
        }
        private void fanNumMenu_DropDownItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            Int32 i = Convert.ToInt32(e.ClickedItem.Text);
            FanNum = i - 1;
        }
        private void colorMenu_Click(object sender, EventArgs e)
        {
            colorDialogFan.ShowDialog();
            FanTextColor = colorDialogFan.Color;
            FanBarColor  = colorDialogFan.Color;
        }
        private void dispFanName_MouseHover(object sender, EventArgs e)
        {
            toolTipFicFanNum.SetToolTip(dispFanName, " Cont:" + ficNum.ToString() + " Fan:" + (fanNum + 1).ToString() + " ");
        }
        private void dispFanName_Click(object sender, EventArgs e)
        {
            this.fanDispMenu.Show(this, PointToClient(Cursor.Position));
        }
    }

    
    public class FanDutyBar : UserControl   //ファンのDutyを数値と棒グラフで表示するクラス
    {
        //プロパティ
        public Int32  FanDuty           //Duty値（％）
        {
            get { return fanDuty; }
            set
            {
                fanDuty = value;
                this.BarRefresh();
            }
        }
        public Double ResizeRate        //ファン表示エリアの倍率
        {
            get { return resizeRate; }
            set
            {
                resizeRate = value;
                this.BarRefresh();
            }
        }
        public String FontName          //フォント名称
        {
            get { return fontName; }
            set { fontName = value; }
        }
        public Int32  FontSize          //フォントサイズ
        {
            get { return fontSize; }
            set { fontSize = value; }
        }
        public Color  FanDutyBarColor   //棒グラフの色
        {
            get { return fanDutyBarColor; }
            set { fanDutyBarColor = value; }
        }
        //コンストラクタ
        public FanDutyBar() 
        {
            Load += FanDutyBar_Load;
        }
        //ロード時初期化
        private void FanDutyBar_Load(object sender,EventArgs e) 
        {
            this.Controls.Add(fanDutyNum);
            fanDutyNum.Size       = originalSize;
            fanDutyNum.Location   = new Point(0, 0);
            fanDutyNum.BackColor  = Color.Transparent;
            fanDutyNum.ForeColor  = fanDutyNumColor;
            fanDutyNum.TextAlign  = ContentAlignment.MiddleRight;
            fanDutyNum.Font       = new Font(fontName, (float)fontSize);
            BarRefresh();
        }
        //ローカル変数
        private Size       originalSize = new Size(50,16);
        private Label      fanDutyNum   = new Label();
        private Int32      fanDuty      = 100;
        private Double     resizeRate   = 1.0;
        private String     fontName     = "tahoma";
        private Int32      fontSize     = 9;
        private Color   fanDutyNumColor = Color.Black;
        private Color   fanDutyBarColor = Color.Blue;
        //再表示処理
        private void BarRefresh()   
        {
            try
            {
                this.Size = new Size((Int32)(originalSize.Width * resizeRate),
                                     (Int32)(originalSize.Height * resizeRate));
                fanDutyNum.Size = this.Size;
                fanDutyNum.Image = new Bitmap(fanDutyNum.Size.Width, fanDutyNum.Size.Height);
                Graphics g = Graphics.FromImage(fanDutyNum.Image);
                Rectangle rectBack = new Rectangle(0, (Int32)(2.5 * resizeRate),
                                         (Int32)(originalSize.Width * resizeRate),
                                         (Int32)((originalSize.Height - 3.5) * resizeRate));
                SolidBrush sb = new SolidBrush(Color.LightGray);
                g.FillRectangle(sb, rectBack);
                Rectangle rectBar = new Rectangle(0, (Int32)(2.5 * resizeRate),
                                         (Int32)((double)(fanDuty / 100.0 * originalSize.Width) * resizeRate),
                                         (Int32)((double)(originalSize.Height - 3.5) * resizeRate));
                LinearGradientBrush gb = new LinearGradientBrush(g.VisibleClipBounds,
                                         Color.White, fanDutyBarColor, LinearGradientMode.Vertical);
                g.FillRectangle(gb, rectBar);
                g.Dispose();
                gb.Dispose();
                sb.Dispose();

                fanDutyNum.Text = FanDuty.ToString() + "　";	//V3CSと相違
                fanDutyNum.Font = new Font(fontName, (float)(fontSize * resizeRate));
                fanDutyNum.ForeColor = fanDutyNumColor;
            }
            catch { }
        }
    }
}
