#!/bin/bash

# install libusb : USBにアクセスするためのライブラリをインストール
echo "libusbをインストールします。"
echo ""
sudo apt-get install libusb-1.0-0-dev
if [ $? -eq 0 ]
    then
        echo ""
        echo "libusbは正常にインストールされました。"
    else
        echo ""
        echo "libusbのインストールに失敗しました。"
fi
echo ""
echo "enterキーを押してください"
read a

# copy usb_permission_file : root権限なしでUSBにアクセスするための設定ファイルをコピー
echo "95-Fanduina-permission.rulesをコピーします。"
sudo cp -r ./Settings/95-Fanduina-permission.rules /etc/udev/rules.d
if [ $? -eq 0 ]
    then
        echo "95-Fanduina-permission.rulesは正常にコピーされました。"
    else
        echo "95-Fanduina-permission.rulesのコピーに失敗しました。"
fi
echo ""
echo "enterキーを押してください"
read a

# install lm-sensors : CPU温度を測定するユーティリティをインストール
echo "lm-sensorsをインストールします。"
echo ""
sudo apt-get install lm-sensors
if [ $? -eq 0 ]
    then
        echo ""
        echo "lm-sensorsは正常にインストールされました。"
    else
        echo ""
        echo "lm-sensorsのインストールに失敗しました。"
fi
echo ""
echo "enterキーを押してください"
read a

# setup lm-sensors : lm-sensors の初期設定を行う
echo "lm-sensorsの設定を行います。"
echo "    (YES/no) または (yes/NO) の質問にはenterキーを押してください。"
echo "    ただし、下記のように　/etc/modules に #Chip drivers を追加するかどうかを"
echo "    聞かれたら y を入力してください"
echo "     Do you want to add these lines automatically to /etc/modules? (yes/NO)"
echo ""
sudo sensors-detect
if [ $? -eq 0 ]
    then
        echo "lm-sensorsは正常に設定されました。"
    else
        echo "lm-sensorsの設定に失敗しました。"
fi
echo ""
echo "enterキーを押してください"
read a

# install hddtemp : HDD温度を測定するユーティリティをインストール
echo "hddtempをインストールします。"
echo "  起動時にデーモンを開始しますか？　と言う質問には、＜はい＞を選択してください。"
echo "　その他の質問にはenterキーを押すだけでOKです。"
sudo apt-get install hddtemp
if [ $? -eq 0 ]
    then
        echo ""
        echo "hddtempは正常にインストールされました。"
    else
        echo ""
        echo "hddtempのインストールに失敗しました。"
fi
echo ""
read a

echo "インストールが正常に完了したら、設定を有効にするためPCを再起動してください。"
read a






